/*
 * wath - WALL's Another Tiny HTTPD 
 *    Mon, Mar 4 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "signal_code.h"

#ifdef	LINUX
#include <sys/time.h>
#endif

#define	MAIN_MODULE
#include "status_code.h"
#include "common.h"
#undef	MAIN_MODULE
#include "version.h"

/*
 * ޥ
 */
#define	SEND_REPORT_MAIL	1	/* ʾ彪λ˥᡼𤹤	*/
#define	NO_MAIL			0	/* 𤷤ʤ			*/
#if	!defined(__FreeBSD__)
#define SIG_T			void*
#else
#define SIG_T			sig_t
#endif

/*
 * ɽؿ
 */
static void	SetSignalHandler();
static void	ShutdownServer();
static void	SigchldHandler();
static void	Usage();
static void	Detach();
static void	RecordPID();
static int	GetLines();
static void	AcceptLoop();

/*
 * ɽѿ
 */
static send_mail;

#ifdef	DEBUG
void Debug();
#endif	/* DEBUG */

/*
 * ؿ̾:	SetSignalHandler
 * ǽ:	ʥ롦ϥɥ
 * :	ʤ
 */
static void SetSignalHandler(void)
{
  /* ʥ롦ϥɥ	*/
  signal(SIGHUP,  (SIG_T)ReConfiguration);	/* ϥ󥰥å		  */
  signal(SIGINT,  (SIG_T)ShutdownServer);	/* 		  */
  signal(SIGQUIT, (SIG_T)ShutdownServer);	/* λ			  */
  signal(SIGTERM, (SIG_T)ShutdownServer);	/* եȥλ	  */
  signal(SIGSEGV, (SIG_T)ShutdownServer);	/* ơȿ */
  signal(SIGCHLD, (SIG_T)SigchldHandler);	/* ҥץξѲ	  */
}

/*
 * ؿ̾:	ShutdownServer
 * ǽ:	ʥȥåפ
 * :	ʥ롦
 * :	ʤ
 */
static void ShutdownServer(sig)
	int	sig;
{
  char		body[BUF_SIZE];
  const char	subject[] = "Emergency Mail from WATH";
#ifdef	JP_MESG			/* ܸå		*/
  const char	message[] = 
    "ʥμˤꡢWATH λޤ\n\
WATH ƵưƲ";
#else				/* Ѹå		*/
  const char	message[] = "WATH was terminated by signal";
  const char	reboot[]  = "You must run WATH again !";
#endif	/* JP_MESG */

  signal(sig, SIG_IGN);		/* ȯʥ̵	*/
  (void)shutdown(soc,2);	/* ³Υåȥ	*/
  (void)close(soc);		/* åȵһҤΥ	*/
  (void)shutdown(sd,2);		/* ³Υåȥ	*/
  (void)close(sd);		/* åȵһҤΥ	*/
#ifndef	DEBUG
  				/* ᡼ʸκ		*/
#ifdef	JP_MESG			/* ܸʸ			*/
  (void)sprintf(body, "(%s)%s", signal_code[sig], message);
#else				/* Ѹʸ			*/
  (void)sprintf(body, "%s(%s)\n%s", message, signal_code[sig], reboot);
#endif	/* JP_MESG */
  (void)unlink(serv.wath_pid);	/* PID ¸եκ	*/
  if (send_mail != NO_MAIL) {
    SendMail(subject, body);	/* Ԥ˥᡼		*/
  }
#endif	/* DEBUG */
  exit(1);			/* λ	*/
}

/*
 * ؿ̾:	sigchld_handler
 * ǽ:	ҥץνλԤ(ӡץʤ)
 * :	ʤ
 */
static void SigchldHandler(void)
{
  for (;;) {			/* wait ԤƤҥץλ */
    if (wait(NULL) != 0) {	/* ޤԤ	*/
      break;
    }
  }

#if SYSTEM_V || LINUX		/* ʥ롦ϥɥκ	*/
  signal(SIGCHLD, (SIG_T)SigchldHandler);
#endif
}

/*
 * ؿ̾:	Usage
 * ǽ:	ץɸ२顼Ϥɽ
 * :	ʤ
 */
static void Usage(void)
{
  (void)fprintf(stderr, "%s\n", Copyright);
  (void)fprintf(stderr, 
		"usage: %s [-r config_file][-p port][-nomail][-jisout]\n",
		Program);
  exit(0);
}

/*
 * ؿ̾:	Detach
 * ǽ:	üڤΥȿåκ
 * :	ʤ
 */
static void Detach(void)
{
  pid_t	pid;

  /* СΥ롼ȡǥ쥯ȥ	*/
  if (chdir(serv.file.real) < 0) {
    perror(serv.file.real);
    exit(1);
  }

#ifndef	DEBUG
  /* üڤΥ򤹤	*/
  if (fork() > 0) {
    exit(0);
  }

  /* åκ	*/
#ifdef	HAVE_SETSID
  if((pid = setsid()) == -1) {
      (void)fprintf(stderr, "wath: setsid failed\n");
      exit(1);
  }
#else
#ifdef	SYSTEM_V
  if((pid = setpgrp()) == -1) {
#else
  if((pid = setpgrp(getpid(),0)) == -1) {
#endif	/* SYSTEM_V */
      (void)fprintf(stderr, "wath: setpgrp failed\n");
      exit(1);
  }
#endif	/* HAVE_SETSID */
#endif	/* DEBUG */
}

/*
 * ؿ̾:	RecordPID
 * ǽ:	WATH Υץ ID ե¸
 * :	ʤ
 */
static void RecordPID(void)
{
  register FILE	*fp;

  if (access(serv.wath_pid, F_OK) == 0) {	/* ʣưΥå	*/
    (void)fprintf(stderr, "\n%s file exist. wath is already running.\n",
		  serv.wath_pid);
    exit(1);
  }

  if ((fp = fopen(serv.wath_pid, "w")) != NULL) {
    (void)fprintf(fp, "%d\n", (int)getpid());
    (void)fclose(fp);
  }
}

/*
 * ؿ̾:	GetLines
 * ǽ:	ԤĤϤ
 * :	ϤХåեؤΥݥ󥿡ХåեΥ
 * :	(SUCCESS) or (FAILURE)
 */
static int GetLines(s, size)
	char	*s;
	int	size;
{
  register int	i, ret, cr , lf;

  i = ret = cr = lf  = 0;		/* Ƽѿν		*/

  while (1) {
    if ((ret = read(sd, &s[i], 1)) <= 0) {
      s[i] = EOL;			/* ʸüդ	*/
      return(FAILURE);
    }

    if ((s[i] != CR) && (s[i] != LF)) {
      cr = lf = 0;			/* CR LF 󥿤Υꥢ	*/
    }

    if (s[i] == CR) {			/* CR 󥿤ι		*/
      cr++;
    }
    else if (s[i] == LF) {		/* LF 󥿤ι		*/
      lf++;
    }

    /* CRLF ΣϢ³ϤХåեνüʤϤμդλ	*/
    if ((cr + lf >= 4) || (i == (size-1))) {
      s[i] = EOL;			/* ʸüդ	*/
      return(SUCCESS);
    }

    i++;
  }
}

/*
 * ؿ̾:	AcceptLoop
 * ǽ:	饤Ȥ׵ꡢ롣
 * :	ʤ
 */
static void AcceptLoop(void)
{
  int		width, n;
  pid_t		pid;
  fd_set	mask, mread;
  char		buf[BUF_SIZE];

  FD_ZERO(&mask);
  FD_SET(soc, &mask);
  width = soc + 1;

  /* ̵¥롼	*/
  while (1) {
    mread = mask;
    n = select(width, &mread, NULL, NULL, NULL);
    if (FD_ISSET(soc, &mread)) {
      AcceptConnection();
      if (AccessCheck() == ACCESS_ALLOW) {	/* å	*/
        if ((pid = fork()) == (pid_t)0) {	/* ҥץ		*/
	  (void)close(soc);
	  if (GetLines(buf, BUF_SIZE)) {	/* ׵	*/
#ifdef	DEBUG
	    (void)fprintf(stderr, "BUF_SIZE[%d]\n\n", strlen(buf));
#endif	/* DEBUG */
	    TreatRequest(buf);			/* ׵ν		*/
	  }
	  (void)close(sd);
	  exit(0);
	}
	else {					/* ƥץ		*/
	  (void)close(sd);
	}
      }
    }
  }
}

/*
 * ᥤؿ
 */
int main(argc, argv)
	int	argc;
	char	**argv;
{
  int	i, port=0;

  /* 	*/
  send_mail = SEND_REPORT_MAIL;

  /* ǥեȡѥ᡼	*/
  DefaultConfiguration();

  /* ν	*/
  for (i=1; i<argc; i++) {
    if (IsNEqual(argv[i], "-r",2) && (i + 1 < argc)) {
      config_file = argv[++i];
    }
    else if (IsNEqual(argv[i], "-p",2) && (i + 1 < argc)) {
      port = atoi(argv[++i]);
    }
    else if (IsNEqual(argv[i], "-nomail",7)) {
      send_mail = NO_MAIL;
    }
    else if (IsNEqual(argv[i], "-jisout",7)) {
      serv.jisout = JISOUT;
    }
    else {
      Usage();
    }
  }

#ifdef	DEBUG
  Debug();
#endif	/* DEBUG */

  /* եɤ߹	*/
  Configuration();

  /* MIME Type ǡ١ν	*/
  MakeMimeTypesDataBase();

  /* ǽʥۥȤΥơ֥	*/
  InitAccessHosts();

  /*  URL ơ֥ν	*/
  InitPrivateURLList();

  /* Ϳ줿ݡֹͭˤ	*/
  if (port != 0) {
    serv.port = port;
  }

#ifdef	DEBUG
  Debug();
#endif	/* DEBUG */

  SetSignalHandler();	/* ʥ롦ϥɥ	*/
  Detach();		/* üڤΥ򤹤	*/
  InitConnection();	/* ͥåȥطν	*/

#ifndef	DEBUG
  RecordPID();		/* ץ ID ե¸	*/

  (void)fclose(stdin);	/* ɸϤĤ		*/
#ifdef	NO_USE_CGI	/* CGI ѤʤʤƤ褤	*/
  (void)fclose(stdout);	/* ɸϤĤ		*/
  (void)fclose(stderr);	/* ɸ२顼ϤĤ	*/
#endif	/* NO_USE_CGI */
#endif	/* DEBUG */

  AcceptLoop();		/* ׵̵¥롼	*/

  return(1);		/* 	*/
}

#ifdef	DEBUG
void Debug(void)
{
  (void)fprintf(stderr, "PORT:\t%d\n", serv.port);
  (void)fprintf(stderr, "ADMIN:\t%s\n", serv.admin);
  (void)fprintf(stderr, "ROOT:\t%s\n", serv.root);
  (void)fprintf(stderr, "NAME:\t%s\n", serv.name);
  (void)fprintf(stderr, "MIME:\t%s\n", serv.mime);
  (void)fprintf(stderr, "ALLOW:\t%s\n", serv.access.allow);
  (void)fprintf(stderr, "DENY:\t%s\n", serv.access.deny);
  (void)fprintf(stderr, "USER:\t%s\n", serv.private);
  (void)fprintf(stderr, "ERROR:\t%s\n", serv.log.error);
  (void)fprintf(stderr, "ACCESS:\t%s\n", serv.log.access);
  (void)fprintf(stderr, "CGI:\t%s\t%s\n", serv.cgi.virtual,serv.cgi.real);
  (void)fprintf(stderr, "FILE:\t%s\t%s\n", serv.file.virtual,serv.file.real);
  (void)fprintf(stderr, "WELCOME:\t%s\n\n", serv.welcome);
}
#endif	/* DEBUG */
